wGDB = {sellGrays = false}
wGMDB = {}
local wG = "|cffe1a500w|cff69ccf0Gold|cffffffff"
local ldb = LibStub("LibDataBroker-1.1")
local wGold = CreateFrame("Frame", "Broker_wGold")
local realmName = GetRealmName()
local myName = UnitName("player")
local myMoneyTotal,startingGold,merchantGold = 0,0,0

local backdrop = {
  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
  edgeSize = 16,
  insets = {left = 4, right = 4, top = 4, bottom = 4,}
}

local function manualResetWeekGold()
	startingGold = GetMoney();
	wGMDB[realmName]["week_info"]["gold"] = 0;
	wGMDB[realmName]["today_info"]["gold"] = 0;
	wGMDB[realmName]["last_reset_date"] = wGMDB[realmName]["today_info"]["date"];
end

local function resetWeekGold()
	wGMDB[realmName]["week_info"]["gold"] = 0;
	wGMDB[realmName]["last_reset_date"] = wGMDB[realmName]["today_info"]["date"];
end

local function moneyFormat(copper, earned)
	local moneyGold = floor(abs(copper / 10000))
	local moneySilver = floor(abs(mod(copper / 100, 100)))
	local moneyCopper = floor(abs(mod(copper, 100)))
	if (earned==1) then -- Gold (earned) tooltip
		if (copper<0) then
			return string.format("|cffff0000 - %d|cffffcc00g |cffff0000%d|cffc0c0c0s |cffff0000%d|cff996600c",moneyGold,moneySilver,moneyCopper)
		elseif (copper>0) then
			return string.format("|cff00ff00 %d|cffffcc00g |cff00ff00%d|cffc0c0c0s |cff00ff00%d|cff996600c",moneyGold,moneySilver,moneyCopper)
		elseif (copper==0) then
			return string.format("%d|cffffcc00g |cffffffff%d|cffc0c0c0s |cffffffff%d|cff996600c",moneyGold,moneySilver,moneyCopper)
		end
	else
		return string.format("|cffffffff%d|cffffcc00g |cffffffff%d|cffc0c0c0s |cffffffff%d|cff996600c",moneyGold,moneySilver,moneyCopper)
	end
end
local function altRemove(alt)
	local name = alt.value
	for k,v in pairs(wGMDB[realmName]) do
		if (k==name) then
			print(string.format("|cffffff00%s has been removed from the %s|cffffff00 database",name,wG))
			wGMDB[realmName][name] = nil
		end
	end
end

-- Choose the day that the weekly data resets on
local function weekDaySelect(self, dayVal)
	UIDropDownMenu_SetSelectedID(menuFrame, self:GetID());
	wGMDB["reset_day"] = dayVal;
end

wGoldResetConfirm = CreateFrame("Frame", "wGoldResetConfirm");
local f = wGoldResetConfirm;
f:SetBackdrop(backdrop);
f:SetBackdropColor(0,0,0,0.9);
f:SetSize(200,100);
f:SetPoint("CENTER",UIParent,"CENTER",0,150);
f.tex = f:CreateTexture("wGoldResetConfirmTexture","OVERLAY");
f.tex:SetSize(40,40);
f.tex:SetTexture("interface\\minimap\\tracking\\auctioneer");
f.tex:SetPoint("CENTER",f,"TOPLEFT",15,-15);
f.title = f:CreateFontString("wGoldResetConfirmTitle","OVERLAY","ChatFontNormal");
f.title:SetText(wG);
f.title:SetPoint("TOP",f,"TOP",0,-10);

f.desc = f:CreateFontString("wGoldResetConfirmDescription","OVERLAY","ChatFontSmall")
f.desc:SetText("Are you sure you want to reset\nthis week's data?")
f.desc:SetPoint("TOP",f.title,"BOTTOM",0,-5)

f.yes = CreateFrame("Button","wGoldResetConfirmYes",f,"GameMenuButtonTemplate");
f.yes:SetSize(50,20);
f.yes:SetText("Yes");
f.yes:SetPoint("RIGHT",f,"BOTTOM",-5,30);
f.yes:SetScript("OnClick",function(self)
	manualResetWeekGold();
	f:Hide(); 
end);

f.no = CreateFrame("Button","wGoldResetConfirmNo",f,"GameMenuButtonTemplate");
f.no:SetSize(50,20);
f.no:SetText("No");
f.no:SetPoint("LEFT",f,"BOTTOM",5,30);
f.no:SetScript("OnClick",function(self) f:Hide() end);

f.ver = f:CreateFontString("wGoldResetConfirmVersion","OVERLAY","GameFontWhiteTiny")
f.ver:SetPoint("BOTTOMRIGHT",f,"BOTTOMRIGHT",-5,5)
f.ver:SetText("Ver "..GetAddOnMetadata("Broker_wGold","Version"))
f.ver:SetJustifyH("RIGHT")
f.close = CreateFrame("Button","wGoldResetConfirmClose",f,"UIPanelCloseButton")
f.close:SetSize(20,20)
f.close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-2,-2)
f.close:SetScript("OnClick",function(self) f:Hide() end)
f:Hide()

local function manualWeekResetConfirm()
	wGoldResetConfirm:Show();
end

local menuFrame = CreateFrame("Frame", "menuFrame", UIParent, "UIDropDownMenuTemplate", "MENU")
local alts = {
	--[[{text = "Alt1", value = "1000g"},
	{text = "Alt2", value = "100g"},
	{text = "Alt3", value = "10g"},
	{text = "Alt4", value = "1g"}]]
}
local weekDays = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
local options = {
	{text = "Auto-sell grays", value = "sellGrays", isNotRadio = true, keepShownOnClick = true, func = (function() if (wGDB.sellGrays==false) then wGDB.sellGrays = true else wGDB.sellGrays = false end end)},
	{text = "Remove an alt", value = "altList", notCheck = true, hasArrow = true},
	{text = "Weekly reset day", value = "dayList", notCheck = true, hasArrow = true},
	{text = "Manually reset week", value = "manualWeekReset", notCheck = true, hasArrow = false, func = (function() manualWeekResetConfirm() end)},
	{text = nil, value = nil, disabled = true, notCheck = true},
	{text = "Close", value = nil, notCheck = true, keepShowOnClick = false, notCheck = true}
}
local function initialize(self, level)
	local val = UIDROPDOWNMENU_MENU_VALUE
	if (level==1) then
		local title = UIDropDownMenu_CreateInfo()
		title = UIDropDownMenu_CreateInfo()
		title.text = wG
		title.isTitle = true
		title.notCheckable = true
		UIDropDownMenu_AddButton(title, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(options) do
			info = UIDropDownMenu_CreateInfo()
			if (v.disabled~=nil) then info.disabled = v.disabled end
			if (v.notCheck~=nil) then info.notCheckable = v.notCheck end
			if (v.hasArrow~=nil) then info.hasArrow = v.hasArrow info.menuList = v.subMenu end
			if (v.isNotRadio~=nil) then info.isNotRadio = v.isNotRadio end
			if (v.func~=nil) then info.func = v.func end
			info.text = v.text
			info.value = v.value
			info.checked = wGDB[v.value]
			info.keepShownOnClick = v.keepShownOnClick
			UIDropDownMenu_AddButton(info, level)
	   end
	elseif (level==2) then
		local info = UIDropDownMenu_CreateInfo()
		if (val == "altList") then		
			for k,v in pairs(alts) do
				info = UIDropDownMenu_CreateInfo()
				info.text = v.text
				info.value = v.value
				info.func, info.arg1 = altRemove, v.value
				info.isNotRadio = true
				info.notCheckable = true
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (val == "dayList") then
			for k,v in pairs(weekDays) do
				info = UIDropDownMenu_CreateInfo();
				info.text = v;				
				info.func, info.arg1 = weekDaySelect, k;
				info.keepShownOnClick = true
				UIDropDownMenu_AddButton(info, level);
				if (k == wGMDB["reset_day"]) then 				
					UIDropDownMenu_SetSelectedID(menuFrame, k);
				end
			end			
		end
	end
end
UIDropDownMenu_Initialize(menuFrame, initialize, "MENU")
UIDropDownMenu_SetWidth(menuFrame, 100);
UIDropDownMenu_SetButtonWidth(menuFrame, 124)
UIDropDownMenu_JustifyText(menuFrame, "LEFT")



local Broker_wGold = ldb:NewDataObject("Broker_wGold", {
	type = "data source",
	text = "0g 0s 0c",
	icon = "interface\\minimap\\tracking\\auctioneer",
	label = wG,
	OnClick = function(self, button)
		if button == "RightButton" then
			ToggleDropDownMenu(1, nil, menuFrame, self, 0, 15)
		end
	end,
	OnTooltipShow = function(tooltip)
		local moneyTotal = 0
		--[[local moneyToday = 0
		local moneyWeek = 0
		if (wGMDB[realmName]["today_info"]["gold"]~=nil) then moneyToday = moneyFormat((wGMDB[realmName]["today_info"]["gold"] + (GetMoney() - startingGold)),1) else moneyToday = 0 end
		if (wGMDB[realmName]["week_info"]["gold"]~=nil) then moneyWeek = moneyFormat((wGMDB[realmName]["week_info"]["gold"] + (GetMoney() - startingGold)),1) else moneyWeek = 0 end]]
		tooltip:AddLine(wG..":")
		tooltip:AddLine(" ")
		tooltip:AddDoubleLine("Gold earned (this session):", moneyFormat((GetMoney() - startingGold), 1),1,1,1,1,1,1)
		tooltip:AddDoubleLine("Gold earned (today):", moneyFormat((wGMDB[realmName]["today_info"]["gold"] + (GetMoney() - startingGold)),1),1,1,1,1,1,1)
		tooltip:AddDoubleLine("Gold earned (this week):", moneyFormat((wGMDB[realmName]["week_info"]["gold"] + (GetMoney() - startingGold)),1),1,1,1,1,1,1)
		tooltip:AddLine("________________________")
		tooltip:AddLine(" ")
		for k,v in pairs(wGMDB[realmName]) do
			if (k~=nil) and(k~="today_info") and (k~="week_info") and (k~="last_reset_date") then
				tooltip:AddDoubleLine(k..":", (moneyFormat(v)),1,1,1,1,1,1)
				moneyTotal = moneyTotal + v
			end
		end
		tooltip:AddLine("________________________")
		tooltip:AddLine(" ")
		tooltip:AddDoubleLine("Total:", moneyFormat(moneyTotal),1,1,1,1,1,1)
		tooltip:AddLine(" ")
		tooltip:AddLine("|cff69ccf0Right-Click|cffffd200 for options")
	end,
})

local function moneyUpdate()
	myMoneyTotal = GetMoney()
	local dateInfo = date("*t")
	Broker_wGold.text = (moneyFormat(myMoneyTotal))
	if (wGMDB["reset_day"] == nil) then wGMDB["reset_day"] = 1 end; -- Sunday
	if (wGMDB[realmName]==nil) then wGMDB[realmName] = {} end
	wGMDB[realmName][myName] = GetMoney()
	if (wGMDB[realmName]["today_info"]==nil) then wGMDB[realmName]["today_info"] = {} end
	if (wGMDB[realmName]["today_info"]["gold"]==nil) then wGMDB[realmName]["today_info"]["gold"] = 0 end
	if (wGMDB[realmName]["today_info"]["date"]~=(dateInfo.month.."-"..dateInfo.day.."-"..dateInfo.year)) then wGMDB[realmName]["today_info"]["gold"] = 0 end
	if (wGMDB[realmName]["week_info"]==nil) then wGMDB[realmName]["week_info"] = {} end
	if (wGMDB[realmName]["week_info"]["gold"]==nil) then wGMDB[realmName]["week_info"]["gold"] = 0 end
	if (wGMDB[realmName]["week_info"]["gold"]==0) and (wGMDB[realmName]["today_info"]["gold"]~=0) then wGMDB[realmName]["week_info"]["gold"]=wGMDB[realmName]["today_info"]["gold"] end
	if (wGMDB[realmName]["week_info"]["day"]==nil) then wGMDB[realmName]["week_info"]["day"] = dateInfo.wday end
	if (wGMDB[realmName]["last_reset_date"]==nil) then wGMDB[realmName]["last_reset_date"] = "0-0-0" end
	
	--Old reset method
	--if (wGMDB[realmName]["week_info"]["day"]>dateInfo.wday) then wGMDB[realmName]["week_info"]["gold"] = 0 end		
	
	-- This is comparing all old data at this point before setting the new data
	if (wGMDB[realmName]["today_info"]["date"] ~= (dateInfo.month.."-"..dateInfo.day.."-"..dateInfo.year)) then
		if (wGMDB["reset_day"] == dateInfo.wday) and (wGMDB[realmName]["week_info"]["day"] ~= dateInfo.wday) then resetWeekGold() end
		if (wGMDB[realmName]["week_info"]["day"] > wGMDB["reset_day"]) and (dateInfo.wday < wGMDB["reset_day"]) then resetWeekGold() end
		if (wGMDB[realmName]["week_info"]["day"] < wGMDB["reset_day"]) and (dateInfo.wday > wGMDB["reset_day"]) then resetWeekGold() end
		if (wGMDB["reset_day"] == 7 or wGMDB["reset_day"] == 1) and (wGMDB[realmName]["week_info"]["day"] > dateInfo.wday) then resetWeekGold() end
		if (wGMDB[realmName]["week_info"]["day"] == dateInfo.wday) then resetWeekGold() end
	end
	-- Save new date and day values
	wGMDB[realmName]["week_info"]["day"] = dateInfo.wday
	wGMDB[realmName]["today_info"]["date"]  = (dateInfo.month.."-"..dateInfo.day.."-"..dateInfo.year)
	
	
	
	-- STAY AWAY; THERE BE TROLLS IN HERE
	--[[
	if (dateInfo.wday == wGMDB["reset_day"]) and (wGMDB[realmName]["last_reset_date"] ~= wGMDB[realmName]["today_info"]["date"]) then
		resetWeekGold();
	end

	elseif (wGMDB[realmName]["last_reset_date"] ~= wGMDB[realmName]["today_info"]["date"]) then
		local lastResetMonth, lastResetDate, lastResetYear = strsplit("-", wGMDB[realmName]["last_reset_date"]);
		local todayMonth, todayDate, todayYear = strsplit("-", wGMDB[realmName]["today_info"]["date"]);
		
		-- Weekly data has never reset before, just skip
		if (wGMDB[realmName]["last_reset_date"] == "0-0-0") then
			return;
		end
		
		if (lastResetYear == todayYear) then
			if (lastResetMonth == todayMonth) then
				if ((todayDate - lastResetDate) >= 7) then
					resetWeekGold();
				end
			end
		end
		
		
	end
	]]
end

local OnEvent = CreateFrame("Frame")
OnEvent:RegisterEvent("PLAYER_ENTERING_WORLD")
OnEvent:SetScript("OnEvent", function(self, event, arg1, arg2, arg3)
	if (event=="ADDON_LOADED") then
		if (arg1=="Broker_wGold") then
			moneyUpdate()
			for k,v in pairs(wGMDB[realmName]) do
				if (k~=nil) and (k~=myName) and (k~="today_info") and (k~="week_info") and (k~="last_reset_date") then
					table.insert(alts, {text = k, value = k})
				end
			end
		end
	elseif (event=="PLAYER_ENTERING_WORLD") or (event=="PLAYER_MONEY") then
		moneyUpdate()
	elseif (event=="PLAYER_LOGIN") then
		startingGold = GetMoney()
	elseif (event=="PLAYER_MONEY") then
		moneyUpdate()
	elseif (event=="PLAYER_LOGOUT") then
		wGMDB[realmName]["today_info"]["gold"] = (wGMDB[realmName]["today_info"]["gold"] + (myMoneyTotal - startingGold))
		wGMDB[realmName]["week_info"]["gold"] = (wGMDB[realmName]["week_info"]["gold"] + (myMoneyTotal - startingGold))
	elseif (event=="MERCHANT_SHOW") then
		merchantGold = GetMoney()
		if (wGDB.sellGrays==true) then
			local sold = false
			local earned = 0
			for bagNum = 0,4 do
				for slotNum = 1,GetContainerNumSlots(bagNum) do
					local item = GetContainerItemLink(bagNum, slotNum)
					--if (item) and (string.find(item, "ff9d9d9d")) then --Look for gray
					if (item) then
						local name,_,qual,_,_,_,_,_,_,_,vend = GetItemInfo(item)
						if (qual==0) and (vend~=0) then
							PickupContainerItem(bagNum, slotNum)
							PickupMerchantItem()
							earned = earned + vend						
							sold = true
						end
					end
				end
			end
			if (sold==true) then
				print(string.format("%s: Some gray quality items have been automatically sold for %s",wG,moneyFormat(earned)))
			end
		end
	end
end)
OnEvent:RegisterEvent("ADDON_LOADED")
OnEvent:RegisterEvent("PLAYER_LOGIN")
OnEvent:RegisterEvent("PLAYER_MONEY")
OnEvent:RegisterEvent("PLAYER_LOGOUT")
OnEvent:RegisterEvent("MERCHANT_SHOW")